﻿using System;

namespace BGShell.PowerShell.Runspaces
{
    [Serializable]
    internal struct TextRange
    {
        private readonly int _start;
        private readonly int _end;

        public TextRange(int start, int end)
        {
            _start = start;
            _end = end;
        }

        /// <summary>
        /// Start of the range, relative to the
        /// begin of edit area.
        /// </summary>
        public int Start
        {
            get { return _start; }
        }

        /// <summary>
        /// End of the range, relative to the
        /// begin of edit area.
        /// </summary>
        public int End
        {
            get { return _end; }
        }
    }
}
